- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Namespace List
- Namespace Members

# fm Namespace Reference

Namespace that contains the overwritten STL classes. More...

## Classes
class | vector
| A dynamically-sized array. More...
class | pvector
| A dynamically-sized array of pointers. More...
class | comparator
| A utility to sort arrays. More...
class | icomparator
| A utility to sort an array in descending order, using operator<. More...
class | pcomparator
| A utility to sort arrays of pointer elements. More...
class | pair
| A simple pair template. More...
class | tree
| An auto-balancing tree. More...
class | set
| A STL set. More...
class | map
| A STL map. More...
class | stringT
| A string template. More...
## Typedefs
typedef void *(* | AllocateFunc )(size_t size)
| An allocation function type.
typedef void(* | FreeFunc )(void *buffer)
| A deallocation function type.
typedef stringT< char > | string
| A string of UTF8 characters.
## Functions
FCOLLADA_EXPORT void | SetAllocationFunctions (AllocateFunc a, FreeFunc f)
| Sets the FCollada memory allocation / deallocation functions.
FCOLLADA_EXPORT void * | Allocate (size_t byteCount)
| Allocates a requested amount of memory.
FCOLLADA_EXPORT void | Release (void *buffer)
| Releases a memory buffer.
template<class Type1>
void | Construct (Type1 *o)
| Construct the object at a given pointer.
template<class Type1, class Type2>
void | Construct (Type1 *o, const Type2 &value)
| Construct the object at a given pointer.
template<class T>
void | swap (T &a, T &b)
| A utility function to swap data.
template<class CharT>
stringT< CharT > | operator+ (const stringT< CharT > &A, const stringT< CharT > &B)
| Concatenates two strings.
template<class CharT>
stringT< CharT > | operator+ (const CharT *A, const stringT< CharT > &B)
| See above.
template<class CharT>
stringT< CharT > | operator+ (const stringT< CharT > &A, const CharT *B)
| See above.
template<class CharT>
stringT< CharT > & | operator+= (stringT< CharT > &A, const stringT< CharT > &B)
| See above.
template<class CharT>
stringT< CharT > & | operator+= (stringT< CharT > &A, const CharT *B)
| See above.
template<class CharT>
stringT< CharT > & | operator+= (stringT< CharT > &A, const CharT &B)
| Appends a character to a string.
template<class CharT>
bool | operator< (const stringT< CharT > &A, const stringT< CharT > &B)
| Retrieves whether a first string is lesser than a second string.
template<class CharT>
bool | operator== (const stringT< CharT > &A, const stringT< CharT > &B)
| Retrieves whether a first string is equal to a second string.
template<class CharT>
bool | operator!= (const stringT< CharT > &A, const stringT< CharT > &B)
| Retrieves whether a first string differs from a second string.
template<class CharT>
bool | operator!= (const stringT< CharT > &A, const CharT *B)
| Retrieves whether a first string differs from a second string.

## Detailed Description

Namespace that contains the overwritten STL classes.

## Typedef Documentation

typedef void*(* fm::AllocateFunc)(size_t size)

  | An allocation function type. Parameters:
  | size | The size, in bytes, to allocate.
Returns: The allocated buffer or NULL if not enough memory is available.

typedef void(* fm::FreeFunc)(void *buffer)

  | A deallocation function type. Parameters:
  | buffer | The memory buffer to deallocate.

## Function Documentation

FCOLLADA_EXPORT void* fm::Allocate | ( | size_t | byteCount | ) |

  | Allocates a requested amount of memory. Parameters:
  | byteCount | The amount of memory to allocate, in bytes.
Returns: A pointer to the memory address. This pointer will be NULL if there is not enough memory to allocate.

template<class Type1, class Type2>
void fm::Construct | ( | Type1 * | o,
|  | const Type2 & | value
| ) | `[inline]`

  | Construct the object at a given pointer. Parameters:
  | o | A pointer to the object.
  | value | The value to copy.

template<class Type1>
void fm::Construct | ( | Type1 * | o | ) | `[inline]`

  | Construct the object at a given pointer. Parameters:
  | o | A pointer to the object.

template<class CharT>
bool fm::operator!= | ( | const stringT< CharT > & | A,
|  | const CharT * | B
| ) |

  | Retrieves whether a first string differs from a second string. Parameters:
  | A | A first string.
  | B | A second string.
Returns: Whether the first string differs from the second string.

template<class CharT>
bool fm::operator!= | ( | const stringT< CharT > & | A,
|  | const stringT< CharT > & | B
| ) |

  | Retrieves whether a first string differs from a second string. Parameters:
  | A | A first string.
  | B | A second string.
Returns: Whether the first string differs from the second string.

template<class CharT>
stringT<CharT> fm::operator+ | ( | const stringT< CharT > & | A,
|  | const stringT< CharT > & | B
| ) |

  | Concatenates two strings. Parameters:
  | A | A first string.
  | B | A second string.
Returns: The concatenation of the two strings.

template<class CharT>
stringT<CharT>& fm::operator+= | ( | stringT< CharT > & | A,
|  | const CharT & | B
| ) |

  | Appends a character to a string. Parameters:
  | A | A string.
  | B | A character.
Returns: The concatenation of the string with the character.

template<class CharT>
bool fm::operator< | ( | const stringT< CharT > & | A,
|  | const stringT< CharT > & | B
| ) |

  | Retrieves whether a first string is lesser than a second string. This comparison is done solely on the character buffers and not the lengths. Parameters:
  | A | A first string.
  | B | A second string.
Returns: Whether the first string is lesser than the second string.

template<class CharT>
bool fm::operator== | ( | const stringT< CharT > & | A,
|  | const stringT< CharT > & | B
| ) |

  | Retrieves whether a first string is equal to a second string. Parameters:
  | A | A first string.
  | B | A second string.
Returns: Whether the first string is equal to the second string.

FCOLLADA_EXPORT void fm::Release | ( | void * | buffer | ) |

  | Releases a memory buffer. Parameters:
  | buffer | The memory buffer to release.

FCOLLADA_EXPORT void fm::SetAllocationFunctions | ( | AllocateFunc | a,
|  | FreeFunc | f
| ) |

  | Sets the FCollada memory allocation / deallocation functions. Parameters:
  | a | The Allocation function. Defaults to malloc.
  | f | The Deallocation function. Defaults to free.